Properties Methods Events Config Options Direct Link

    ContainerLayout
      AnchorLayout

# Class Ext.layout.AnchorLayout

Package: | Ext.layout
Defined In: | AnchorLayout.js
Class: | AnchorLayout
Subclasses: | AbsoluteLayout, FormLayout
Extends: | ContainerLayout

This is a layout that enables anchoring of contained elements relative to the container's dimensions. If the container is resized, all anchored items are automatically rerendered according to their `anchor` rules.

This class is intended to be extended or created via the layout:'anchor' Ext.Container.layout config, and should generally not need to be created directly via the new keyword.

AnchorLayout does not have any direct config options (other than inherited ones). By default, AnchorLayout will calculate anchor measurements based on the size of the container itself. However, the container using the AnchorLayout can supply an anchoring-specific config property of anchorSize. If anchorSize is specifed, the layout will use it as a virtual container for the purposes of calculating anchor measurements based on it instead, allowing the container to be sized independently of the anchoring logic if necessary. For example:

    var viewport = new Ext.Viewport({
        layout:'anchor',
        anchorSize: {width:800, height:600},
        items:[{
            title:'Item 1',
            html:'Content 1',
            width:800,
            anchor:'right 20%'
        },{
            title:'Item 2',
            html:'Content 2',
            width:300,
            anchor:'50% 30%'
        },{
            title:'Item 3',
            html:'Content 3',
            width:600,
            anchor:'-100 50%'
        }]
    });

## Config Options

Config Options | Defined By
--- | ---

anchor : String
This configuation option is to be applied to child items of a container managed by this layout (ie. configured with l...

This configuation option is to be applied to child `items` of a container managed by this layout (ie. configured with `layout:'anchor'`).

This value is what tells the layout how an item should be anchored to the container. `items` added to an AnchorLayout accept an anchoring-specific config property of anchor which is a string containing two values: the horizontal anchor value and the vertical anchor value (for example, '100% 50%'). The following types of anchor values are supported:

- Percentage : Any value between 1 and 100, expressed as a percentage.
  The first anchor is the percentage width that the item should take up within the container, and the second is the percentage height. For example:

      // two values specified
      anchor: '100% 50%' // render item complete width of the container and
                         // 1/2 height of the container
      // one value specified
      anchor: '100%'     // the width value; the height will default to auto

- Offsets : Any positive or negative integer value.
  This is a raw adjustment where the first anchor is the offset from the right edge of the container, and the second is the offset from the bottom edge. For example:

      // two values specified
      anchor: '-50 -100' // render item the complete width of the container
                         // minus 50 pixels and
                         // the complete height minus 100 pixels.
      // one value specified
      anchor: '-50'      // anchor value is assumed to be the right offset value
                         // bottom offset will default to 0

- Sides : Valid values are `'right'` (or `'r'`) and `'bottom'` (or `'b'`).
  Either the container must have a fixed size or an anchorSize config value defined at render time in order for these to have any effect.
- Mixed :
  Anchor values can also be mixed as needed. For example, to render the width offset from the container right edge by 50 pixels and 75% of the container's height use:

      anchor: '-50 75%'

AnchorLayout

| defaultAnchor : String default anchor for all child container items applied if no anchor or specific width is set on the child item. Defaul... default anchor for all child container items applied if no anchor or specific width is set on the child item. Defaults to '100%'. | AnchorLayout

extraCls : String
An optional extra CSS class that will be added to the container. This can be useful for adding customized styles to t...

An optional extra CSS class that will be added to the container. This can be useful for adding customized styles to the container or any of its children using standard CSS rules. See Ext.Component.ctCls also.

Note: `extraCls` defaults to `''` except for the following classes which assign a value by default:

- Absolute Layout : `'x-abs-layout-item'`
- Box Layout : `'x-box-item'`
- Column Layout : `'x-column'`

To configure the above Classes with an extra CSS class append to the default. For example, for ColumnLayout:

    extraCls: 'x-column custom-class'

ContainerLayout

| renderHidden : Boolean True to hide each contained item on render (defaults to false). | ContainerLayout

## Public Properties

Property | Defined By
--- | ---

fieldTpl : Ext.Template
The Ext.Template used by Field rendering layout classes (such as Ext.layout.FormLayout) to create the DOM structure o...
The Ext.Template used by Field rendering layout classes (such as Ext.layout.FormLayout) to create the DOM structure of a fully wrapped, labeled and styled form Field. A default Template is supplied, but this may be overriden to create custom field structures. The template processes values returned from Ext.layout.FormLayout.getTemplateArgs.

ContainerLayout

| if : Object This monitorResize flag will be renamed soon as to avoid confusion with the Container version which hooks onWindowRes... This monitorResize flag will be renamed soon as to avoid confusion with the Container version which hooks onWindowResize to doLayout monitorResize flag in this context attaches the resize event between a container and it's layout | ContainerLayout

## Public Methods

Method | Defined By
--- | ---

parseMargins( `Number|String v` ) : Object
Parses a number or string representing margin sizes into an object. Supports CSS-style margin declarations (e.g. 10, ...
Parses a number or string representing margin sizes into an object. Supports CSS-style margin declarations (e.g. 10, "10", "10 10", "10 10 10" and "10 10 10 10" are all valid options and would return the same result)
Parameters:

- `v` : Number|String
  The encoded margins

Returns:

- `Object`
  An object with margin sizes for top, right, bottom and left

ContainerLayout

## Public Events

This class has no public events.